/*
 * Shoals_Leader Tyler 2000.
 */
   public class Entity_Leader extends Entity {
      int rd = 8;
   
      Entity_Leader(int ix, int iy, int seed) {
         x = ix;
         y = iy;
      
         rnd.setSeed(seed);
         dx = 0;
         dy = 0;
      
         direction = 0;
         i_am_a_leader = true;
         colour = 224;
      
         acceleration = 32;
      
         setInitialSize(EntityManager.general_eggsize, EntityManager.general_eggsize);
         log_mass = 15;
         status = Entity.IMMORTAL | Entity.IMMUNE | Entity.ALWAYS_HOLLOW | Entity.ALWAYS_CIRCULAR;
      }
   
   
      public void makeRing() {
         ship        = new Ships();
         ship.aa_col = 0x000000;
         ship.pixel  = 0.5;
         ship.shadow = 0.5;
         ship.ship_type = 3;
         ship.generateRing(diameter);
      
         ring_image = ship.ship_white;
      }
   
   
      protected void drawRing() {
         // radius = diameter * 3; // + rd + rd;
      	// diameter = diameter * 4; // + rd + rd;
      
         // temp = (diameter >> 1);
      
         if (ring_image == null)
            makeRing();
      
         if (Shoals_Canvas.observer != null) {
            if (Shoals_Grid.graphics_handle != null) {
               Shoals_Grid.graphics_handle.drawImage(ring_image, temp_x, temp_y, diameter, diameter, null); // Shoals_Canvas.observer);
            }
         }
      }
   
   
      final public void draw() {
         // direction = Shoals_Grid.generation & TRIG_TAB_SIZEMO;
      
         preserved_x = ((x) >>> shift);
         preserved_y = ((y) >>> shift);
      
         // radius = radius;
         // diameter = diameter;
      
         temp_x = preserved_x - radius;
         temp_y = preserved_y - radius;
      
         switch (Shoals.quality) {
            case Shoals._QUALITY_0:
               drawRing();
            
               break;
         
            default:
            
            /* case Shoals._QUALITY_1:
            case Shoals._QUALITY_1A:
            case Shoals._QUALITY_2:
            case Shoals._QUALITY_2A:
            case Shoals._QUALITY_3:
            case Shoals._QUALITY_4: 
            */
            
               if (Shoals_Grid.last_colour != colour) {
                  Shoals_Grid.colour = colour;
                  Shoals_Grid.quicklySetUpColour();
               }
            
               Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
            
               break;
         
         }
      }
   
   
      final public void scrub() {
         temp_x = preserved_x - radius;
         temp_y = preserved_y - radius;
      
         switch (Shoals.quality) {
            case Shoals._QUALITY_0:
               Shoals_Grid.graphics_handle.clearRect(temp_x, temp_y, diameter, diameter); // drawRing();
            
               break;
         
            case Shoals._QUALITY_1:
            case Shoals._QUALITY_2:
            case Shoals._QUALITY_3:
            case Shoals._QUALITY_4:
            case Shoals._QUALITY_1A:
            case Shoals._QUALITY_2A:
            case Shoals._QUALITY_3A:
            case Shoals._QUALITY_4A:
               Shoals_Grid.colourZero();
               Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
            
               break;
         
            /*case Shoals._QUALITY_1A:
            case Shoals._QUALITY_2A:
            case Shoals._QUALITY_3A:
            case Shoals._QUALITY_4A:
               Shoals_Grid.graphics_handle.clearRect(temp_x, temp_y, diameter + 1, diameter + 1);
            
               break;
         */
         /*
            case Shoals._QUALITY_1:
               Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
            
               break;
         
            case Shoals._QUALITY_2:
               Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
            
               break;
         
            case Shoals._QUALITY_3:
               Shoals_Grid.graphics_handle.drawLine(preserved_x, temp_y,            temp_x + diameter, preserved_y);
               Shoals_Grid.graphics_handle.drawLine(temp_x + diameter, preserved_y, preserved_x, temp_y + diameter);
               Shoals_Grid.graphics_handle.drawLine(preserved_x, temp_y + diameter, temp_x, preserved_y           );
               Shoals_Grid.graphics_handle.drawLine(temp_x, preserved_y           , preserved_x, temp_y           );
            
               break;
         */
         }
      
      	// Shoals_Grid.graphics_handle.drawOval(preserved_x - radius - 4,preserved_y - radius - 4,diameter + 4,diameter + 8);
      
      
         // Shoals_Grid.graphics_handle.drawLine(preserved_x, preserved_y, preserved_x + ((sin_tab[direction] * diameter) >> lut_shift), preserved_y + ((cos_tab[direction] * diameter) >> lut_shift));
      }
   
   }
