/*
 * ParticleManager Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.image.ImageObserver;
   import java.lang.Math;

   public class ParticleManager extends Object {
      static Particle particle[];
   
      static Particle temp_particle;
   
      static int MAX_PARTICLE_NUMBER = 512; // fixed upper limit...
   
      static int current_max_number = 0;
   
      static int current_number = 0;
   
      static int i;
   
      final public static void initial() {
         particle = new Particle[MAX_PARTICLE_NUMBER];
      }
   
   
      public static void add(int ix, int iy, int idx, int idy, int type) {
         if (current_max_number < MAX_PARTICLE_NUMBER) {
            if (particle[current_max_number] == null) {
               particle[current_max_number++] = new Particle(ix, iy, idx, idy, type);
            }
            else
            {
               particle[current_max_number++].set(ix, iy, idx, idy, type);
            }
         }
      }
   
   
      public static void update() {
         if (Shoals.show_exhaust) {
            if (current_max_number > 0) {
               Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
            
               for (i = 0; i < current_max_number; i++) {
                  particle[i].scrub();
                  particle[i].travel();
               }
            
               // for (i = 0; i < current_max_number; i++) {
               // particle[i].draw();
               // }
            
               Shoals_Grid.graphics_handle.setColor(Color.white);
               i = 0;
               do {
                  if (particle[i].count < 0) {
                     if (i != current_max_number - 1) {
                        temp_particle = particle[i];
                        particle[i] = particle[current_max_number - 1];
                        particle[current_max_number - 1] = temp_particle;
                     }
                  
                     current_max_number--;
                     i--; // loopy?
                  }
                  else
                  {
                     if (i == current_max_number >> 1) {
                        Shoals_Grid.graphics_handle.setColor(Color.yellow);
                     }
                  
                     if (i == current_max_number >> 2) {
                        Shoals_Grid.graphics_handle.setColor(Color.red);
                     }
                  
                     particle[i].draw();
                  }
               
                  i++;
               } while (i < current_max_number);
            }
         }
      
      	// used to leave colour OOO/undefined - so...
         // Shoals_Grid.colour = -1;
         Shoals_Grid.last_colour = -1;
      }
   
   /*
      public static void update() {
         //for (i = 0; i < current_max_number; i++) {
         i = 0;
         do {
            particle[i].scrub();
            particle[i].travel();
            particle[i].draw();
         
            if (particle[i].count < 0) {
            
            }
         
            i++;
         
         } while (i < current_max_number);
      }
   	*/
   
   }
