/*
 * Shoals_Output - Tim Tyler 2000-2000
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.io.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Date;
   import java.awt.image.*;

   public class Shoals_Output {
   
      static int temp;
      static int temp2;
      static Writer out;
      static Entity temp_entity;
      static EntityLink temp_link;
   
      public static void dataDump(String filename) {
         try {
            out = new FileWriter(filename);
         
            writeOut("Creature Key_Node:0 Data:0 ");
         
            for (temp = 0; temp < Shoals.entity_manager.number_of_agents; temp++) {
               writeOut("Agent");
               temp_entity = Shoals.entity_manager.agent[temp];
               writeOut("X:" + temp_entity.x);
               writeOut("Y:" + temp_entity.y);
               // writeOut("DX:" + temp_entity.dx);
               // writeOut("DY:" + temp_entity.dy);
               writeOut("D:" + temp_entity.diameter);
            
               if (temp_entity.colour != 511) {
                  writeOut("C:" + (int)(temp_entity.colour));
               }
               //else
               //{
                  //debug("COLOUR=" + temp_entity.colour);
               //}
            
               if (temp_entity.status != 0) {
                  writeOut("Status:" + temp_entity.status);
               }
            
               writeOut("");
            }
         
            for (temp = 0; temp < Shoals.entity_manager.number_of_leaders; temp++) {
               writeOut("Leader");
               temp_entity = Shoals.entity_manager.leader[temp];
               writeOut("X:" + temp_entity.x);
               writeOut("Y:" + temp_entity.y);
               // writeOut("DX:" + temp_entity.x);
               //writeOut("DY:" + temp_entity.y);
               writeOut("D:" + temp_entity.diameter);
            
               if (temp_entity.colour != 511) {
                  writeOut("C:" + (int)temp_entity.colour);
               }
            
               if (temp_entity.status != 0) {
                  writeOut("Status:" + temp_entity.status);
               }
            
               writeOut("");
            }
         
            for (temp = 0; temp < Shoals.entity_manager.link_manager.number_of_links; temp++) {
               writeOut("Link");
            
               temp_link = Shoals.entity_manager.link_manager.entity_link[temp];
               temp2 = Shoals.entity_manager.getAgentNumber(temp_link.entity1);
               writeOut("One:" + temp2);
            
               temp2 = Shoals.entity_manager.getAgentNumber(temp_link.entity2);
               writeOut("Two:" + temp2);
            
               writeOut("ULL:" + temp_link.upper_length_limit);
               if (temp_link.upper_length_limit != temp_link.lower_length_limit) {
                  writeOut("LLL:" + temp_link.lower_length_limit);
               }
            
               writeOut("E:" + temp_link.elasticity);
               if (temp_entity.colour != 255) {
                  writeOut("C:" + (int)temp_link.colour);
               }
            
               writeOut("");
            
            }
         
            // out.write("End ");
            out.write("\n");
            out.flush();
         }
            catch (Exception e) {
               System.out.println("TT_Error (writeOutFile): " + e.toString());
            }
      }
   
   
      public static void writeOut(String s) {
         try {
            if (s.equals("")) {
               if (Shoals.output_linefeeds) {
                  out.write("\n");
               }
            }
            else
            {
               out.write(s + " ");
            }
         }
            catch (Exception e) {
               System.out.println("TT_Error (writeOutFile): " + e.toString());
            }
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
